// <copyright file="DisplayPreferencesConfiguration.cs" company="PlaceholderCompany">
// Copyright (c) PlaceholderCompany. All rights reserved.
// </copyright>

namespace Jellyfin.Database.Implementations.ModelConfiguration
{
    using System;
    using Jellyfin.Database.Implementations.Entities;
    using Microsoft.EntityFrameworkCore;
    using Microsoft.EntityFrameworkCore.Metadata.Builders;

    /// <summary>
    /// FluentAPI configuration for the DisplayPreferencesConfiguration entity.
    /// </summary>
    public class DisplayPreferencesConfiguration : IEntityTypeConfiguration<DisplayPreferences>
    {
        /// <inheritdoc/>
        public void Configure(EntityTypeBuilder<DisplayPreferences> builder)
        {
            ArgumentNullException.ThrowIfNull(builder);
            builder
                            .HasMany(d => d.HomeSections)
                .WithOne()
                .OnDelete(DeleteBehavior.Cascade);

            builder
                .HasIndex(entity => new { entity.UserId, entity.ItemId, entity.Client })
                .IsUnique();
        }
    }
}
